#define _CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <fcntl.h>
#include <fstream>

#include "confidence_measures.h"
#include <opencv/ml.h>		  

#include <cv.h>
#include <highgui.h>

using namespace cv;
using namespace std;

// GCP
void GCP_write_train_sample(InputArray image_L, InputArray image_R, Mat GT, _DSI DSI_LR, float epsilon_PKR, float sigma_MLM, float sigma_AML, char *output_path, int invalid);

void GCP_confidence(InputArray image_L, InputArray image_R, _DSI DSI_LR, float epsilon_PKR, float sigma_MLM, float sigma_AML, char *forest_path, OutputArray confidence_map);

// Park
void Park_write_train_sample(InputArray image_L, InputArray image_R, Mat GT, _DSI DSI_LR, float epsilon_PKR, float sigma_MLM, float sigma_AML, float s_PER, char *output_path, int invalid);

void Park_confidence(InputArray image_L, InputArray image_R, _DSI DSI_LR, float epsilon_PKR, float sigma_MLM, float sigma_AML, float s_PER, char *forest_path, OutputArray confidence_map);

// ENSEMBLE
void ENSEMBLE_confidence(vector<Mat> features, char *forest_path, OutputArray confidence_map);

//rescaling stereo pair
void ENSEMBLE_rescale(InputArray left_1, InputArray right_1, OutputArray left_2, OutputArray right_2, OutputArray left_3, OutputArray right_3);

//feature vector 
vector<Mat> ENSEMBLE_feature_vector_7(InputArray left_1, InputArray left_2, InputArray left_3, _DSI dsi_1, _DSI dsi_2, _DSI dsi_3);
vector<Mat> ENSEMBLE_feature_vector_23(InputArray left_1, InputArray left_2, InputArray left_3, InputArray right_1, InputArray right_2, InputArray right_3,
	_DSI dsi_1, _DSI dsi_2, _DSI dsi_3, float pkr_epsilon, float per_s, int zsad_radius, int sge_radius, int b1, int b2);

//train data for random forest 
void ENSEMBLE_write_train_sample(vector<Mat> feature_vector, Mat disparity_map, Mat groundtruth, int disp_scale, float threshold, char * file_path, int invalid);
