require 'torch'-- torch
require 'image'-- for image transforms
require 'nn'-- provides all sorts of trainable modules/layers
require 'cudnn'
require 'gfx.js'  -- provides visualization

-- parse command line arguments
if not opt then
print '==> processing options'
cmd = torch.CmdLine()
cmd:text()
cmd:text('SVHN convnet Definition')
cmd:text()
cmd:text('Options:')
cmd:option('-size', 9, 'patch size')
cmd:text()
opt = cmd:parse(arg or {})
end

function create_pbcp_model()	

	local model = nn.Sequential()
	model:add(cudnn.SpatialConvolution(2, 6, 3, 3, 1, 1))
	model:add(cudnn.ReLU())

	model:add(cudnn.SpatialConvolution(6, 4, 3, 3, 1, 1))
	model:add(cudnn.ReLU())

	model:add(cudnn.SpatialConvolution(4, 4, 3, 3, 1, 1))
	model:add(cudnn.ReLU())

	model:add(cudnn.SpatialConvolution(4, 4, 3, 3, 1, 1))
	model:add(cudnn.ReLU())

	model:add(cudnn.SpatialConvolution(4, 2, 7, 7, 1, 1))

	return model
end
